/******************************************************************************
 * File Name   : MX_Device.h
 * Date        : 24/01/2022 13:16:48
 * Description : STM32Cube MX parameter definitions
 * Note        : This file is generated by STM32CubeMX (DO NOT EDIT!)
 ******************************************************************************/

#ifndef __MX_DEVICE_H
#define __MX_DEVICE_H

/*---------------------------- Clock Configuration ---------------------------*/

#define MX_LSI_VALUE                            40000
#define MX_LSE_VALUE                            32768
#define MX_HSI_VALUE                            8000000
#define MX_HSE_VALUE                            8000000
#define MX_HSI14_VALUE                          14000000
#define MX_HSI48_VALUE                          48000000
#define MX_PLLCLKFreq_Value                     48000000
#define MX_PLLMCOFreq_Value                     48000000
#define MX_SYSCLKFreq_VALUE                     48000000
#define MX_HCLKFreq_Value                       48000000
#define MX_MCOFreq_Value                        48000000
#define MX_FCLKCortexFreq_Value                 48000000
#define MX_TimSysFreq_Value                     48000000
#define MX_AHBFreq_Value                        48000000
#define MX_APB1Freq_Value                       48000000
#define MX_APB1TimFreq_Value                    48000000
#define MX_ADCoutputFreq_Value                  14000000
#define MX_FLITFCLKFreq_Value                   8000000
#define MX_CECFreq_Value                        32786
#define MX_I2C1Freq_Value                       8000000
#define MX_I2SFreq_Value                        48000000
#define MX_USART1Freq_Value                     48000000
#define MX_USART2Freq_Value                     48000000
#define MX_RTCFreq_Value                        40000
#define MX_RTCHSEDivFreq_Value                  250000
#define MX_USBFreq_Value                        48000000
#define MX_WatchDogFreq_Value                   40000
#define MX_VCOOutput2Freq_Value                 8000000

/*-------------------------------- CAN        --------------------------------*/

#define MX_CAN                                  1

/* GPIO Configuration */

/* Pin PD0 */
#define MX_CAN_RX_GPIO_Speed                    GPIO_SPEED_FREQ_HIGH
#define MX_CAN_RX_Pin                           PD0
#define MX_CAN_RX_GPIOx                         GPIOD
#define MX_CAN_RX_GPIO_PuPd                     GPIO_NOPULL
#define MX_CAN_RX_GPIO_Pin                      GPIO_PIN_0
#define MX_CAN_RX_GPIO_AF                       GPIO_AF0_CAN
#define MX_CAN_RX_GPIO_Mode                     GPIO_MODE_AF_PP

/* Pin PD1 */
#define MX_CAN_TX_GPIO_Speed                    GPIO_SPEED_FREQ_HIGH
#define MX_CAN_TX_Pin                           PD1
#define MX_CAN_TX_GPIOx                         GPIOD
#define MX_CAN_TX_GPIO_PuPd                     GPIO_NOPULL
#define MX_CAN_TX_GPIO_Pin                      GPIO_PIN_1
#define MX_CAN_TX_GPIO_AF                       GPIO_AF0_CAN
#define MX_CAN_TX_GPIO_Mode                     GPIO_MODE_AF_PP

/*-------------------------------- DMA        --------------------------------*/

#define MX_DMA                                  1

/* NVIC Configuration */

/* NVIC DMA1_Channel2_3_IRQn */
#define MX_DMA1_Channel2_3_IRQn_interruptPremptionPriority 0
#define MX_DMA1_Channel2_3_IRQn_Subriority      0

/*-------------------------------- SPI1       --------------------------------*/

#define MX_SPI1                                 1

/* GPIO Configuration */

/* Pin PE14 */
#define MX_SPI1_MISO_GPIO_Speed                 GPIO_SPEED_FREQ_HIGH
#define MX_SPI1_MISO_Pin                        PE14
#define MX_SPI1_MISO_GPIOx                      GPIOE
#define MX_SPI1_MISO_GPIO_PuPd                  GPIO_NOPULL
#define MX_SPI1_MISO_GPIO_Pin                   GPIO_PIN_14
#define MX_SPI1_MISO_GPIO_AF                    GPIO_AF1_SPI1
#define MX_SPI1_MISO_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PE15 */
#define MX_SPI1_MOSI_GPIO_Speed                 GPIO_SPEED_FREQ_HIGH
#define MX_SPI1_MOSI_Pin                        PE15
#define MX_SPI1_MOSI_GPIOx                      GPIOE
#define MX_SPI1_MOSI_GPIO_PuPd                  GPIO_NOPULL
#define MX_SPI1_MOSI_GPIO_Pin                   GPIO_PIN_15
#define MX_SPI1_MOSI_GPIO_AF                    GPIO_AF1_SPI1
#define MX_SPI1_MOSI_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PB3 */
#define MX_SPI1_SCK_GPIO_Speed                  GPIO_SPEED_FREQ_HIGH
#define MX_SPI1_SCK_Pin                         PB3
#define MX_SPI1_SCK_GPIOx                       GPIOB
#define MX_SPI1_SCK_GPIO_PuPd                   GPIO_NOPULL
#define MX_SPI1_SCK_GPIO_Pin                    GPIO_PIN_3
#define MX_SPI1_SCK_GPIO_AF                     GPIO_AF0_SPI1
#define MX_SPI1_SCK_GPIO_Mode                   GPIO_MODE_AF_PP

/* DMA Configuration */

/* DMA SPI1_TX */
#define MX_SPI1_TX_DMA_DMA_Handle
#define MX_SPI1_TX_DMA_Instance                 DMA1_Channel3
#define MX_SPI1_TX_DMA_Priority                 DMA_PRIORITY_LOW
#define MX_SPI1_TX_DMA_PeriphDataAlignment      DMA_PDATAALIGN_BYTE
#define MX_SPI1_TX_DMA_MemDataAlignment         DMA_MDATAALIGN_BYTE
#define MX_SPI1_TX_DMA_Mode                     DMA_NORMAL
#define MX_SPI1_TX_DMA_Direction                DMA_MEMORY_TO_PERIPH
#define MX_SPI1_TX_DMA_PeriphInc                DMA_PINC_DISABLE
#define MX_SPI1_TX_DMA_MemInc                   DMA_MINC_ENABLE
#define MX_SPI1_TX_DMA_IpInstance

/* NVIC Configuration */

/* NVIC SPI1_IRQn */
#define MX_SPI1_IRQn_interruptPremptionPriority 0
#define MX_SPI1_IRQn_Subriority                 0

/*-------------------------------- SYS        --------------------------------*/

#define MX_SYS                                  1

/* GPIO Configuration */

/*-------------------------------- NVIC       --------------------------------*/

#define MX_NVIC                                 1

/*-------------------------------- GPIO       --------------------------------*/

#define MX_GPIO                                 1

/* GPIO Configuration */

/* Pin PE6 */
#define MX_PE6_GPIO_Speed                       GPIO_SPEED_FREQ_LOW
#define MX_PE6_Pin                              PE6
#define MX_PE6_GPIOx                            GPIOE
#define MX_PE6_PinState                         GPIO_PIN_SET
#define MX_PE6_GPIO_PuPd                        GPIO_NOPULL
#define MX_PE6_GPIO_Pin                         GPIO_PIN_6
#define MX_PE6_GPIO_ModeDefaultOutputPP         GPIO_MODE_OUTPUT_PP

/* Pin PB2 */
#define MX_PB2_GPIO_Speed                       GPIO_SPEED_FREQ_LOW
#define MX_PB2_Pin                              PB2
#define MX_PB2_GPIOx                            GPIOB
#define MX_PB2_PinState                         GPIO_PIN_SET
#define MX_PB2_GPIO_PuPd                        GPIO_NOPULL
#define MX_PB2_GPIO_Pin                         GPIO_PIN_2
#define MX_PB2_GPIO_ModeDefaultOutputPP         GPIO_MODE_OUTPUT_PP

#endif  /* __MX_DEVICE_H */
